> ## Documentation Index
> Fetch the complete documentation index at: https://help.teable.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Post plugin

> Create a plugin



## OpenAPI

````yaml /swagger.json post /plugin
openapi: 3.0.0
info:
  version: 1.0.0
  title: Teable App
  description: Manage Data as easy as drink a cup of tea
  x-logo:
    backgroundColor: '#F0F0F0'
    altText: Teable logo
servers:
  - url: https://app.teable.ai/api
security: []
paths:
  /plugin:
    post:
      tags:
        - plugin
      description: Create a plugin
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                name:
                  type: string
                  minLength: 1
                  maxLength: 20
                description:
                  type: string
                  maxLength: 150
                detailDesc:
                  type: string
                  maxLength: 3000
                logo:
                  type: string
                url:
                  type: string
                  format: uri
                config:
                  type: object
                  properties:
                    contextMenu:
                      type: object
                      properties:
                        width:
                          anyOf:
                            - type: number
                            - type: string
                        height:
                          anyOf:
                            - type: number
                            - type: string
                        x:
                          anyOf:
                            - type: number
                            - type: string
                        'y':
                          anyOf:
                            - type: number
                            - type: string
                        frozenResize:
                          type: boolean
                        frozenDrag:
                          type: boolean
                    view:
                      nullable: true
                    dashboard:
                      nullable: true
                    panel:
                      nullable: true
                helpUrl:
                  type: string
                  format: uri
                positions:
                  type: array
                  items:
                    type: string
                    enum:
                      - dashboard
                      - view
                      - contextMenu
                      - panel
                  minItems: 1
                i18n:
                  type: object
                  example:
                    en:
                      title: Plugin title
                      description: Plugin description
                    zh:
                      title: 插件标题
                      description: 插件描述
                autoCreateMember:
                  type: boolean
              required:
                - name
                - logo
                - positions
      responses:
        '201':
          description: Returns data about the plugin.
          content:
            application/json:
              schema:
                type: object
                properties:
                  id:
                    type: string
                  name:
                    type: string
                  description:
                    type: string
                  detailDesc:
                    type: string
                  logo:
                    type: string
                  url:
                    type: string
                  config:
                    type: object
                    properties:
                      contextMenu:
                        type: object
                        properties:
                          width:
                            anyOf:
                              - type: number
                              - type: string
                          height:
                            anyOf:
                              - type: number
                              - type: string
                          x:
                            anyOf:
                              - type: number
                              - type: string
                          'y':
                            anyOf:
                              - type: number
                              - type: string
                          frozenResize:
                            type: boolean
                          frozenDrag:
                            type: boolean
                      view:
                        nullable: true
                      dashboard:
                        nullable: true
                      panel:
                        nullable: true
                  helpUrl:
                    type: string
                  positions:
                    type: array
                    items:
                      type: string
                      enum:
                        - dashboard
                        - view
                        - contextMenu
                        - panel
                  i18n:
                    type: object
                    example:
                      en:
                        title: Plugin title
                        description: Plugin description
                      zh:
                        title: 插件标题
                        description: 插件描述
                  secret:
                    type: string
                  status:
                    type: string
                    enum:
                      - developing
                      - reviewing
                      - published
                  pluginUser:
                    type: object
                    properties:
                      id:
                        type: string
                      name:
                        type: string
                      email:
                        type: string
                        format: email
                      avatar:
                        type: string
                    required:
                      - id
                      - name
                      - email
                  createdTime:
                    type: string
                required:
                  - id
                  - name
                  - logo
                  - positions
                  - secret
                  - status
                  - createdTime
      security:
        - bearerAuth: []
      x-codeSamples:
        - lang: Shell
          source: |-
            curl --request POST \
              --url https://app.teable.ai/api/plugin \
              --header 'Authorization: Bearer REPLACE_BEARER_TOKEN' \
              --header 'content-type: application/json' \
              --data '{"name":"string","description":"string","detailDesc":"string","logo":"string","url":"http://example.com","config":{"contextMenu":{"width":0,"height":0,"x":0,"y":0,"frozenResize":true,"frozenDrag":true},"view":null,"dashboard":null,"panel":null},"helpUrl":"http://example.com","positions":["dashboard"],"i18n":{"en":{"title":"Plugin title","description":"Plugin description"},"zh":{"title":"插件标题","description":"插件描述"}},"autoCreateMember":true}'
        - lang: JavaScript
          source: |-
            const url = 'https://app.teable.ai/api/plugin';
            const options = {
              method: 'POST',
              headers: {
                Authorization: 'Bearer REPLACE_BEARER_TOKEN',
                'content-type': 'application/json'
              },
              body: '{"name":"string","description":"string","detailDesc":"string","logo":"string","url":"http://example.com","config":{"contextMenu":{"width":0,"height":0,"x":0,"y":0,"frozenResize":true,"frozenDrag":true},"view":null,"dashboard":null,"panel":null},"helpUrl":"http://example.com","positions":["dashboard"],"i18n":{"en":{"title":"Plugin title","description":"Plugin description"},"zh":{"title":"插件标题","description":"插件描述"}},"autoCreateMember":true}'
            };

            try {
              const response = await fetch(url, options);
              const data = await response.json();
              console.log(data);
            } catch (error) {
              console.error(error);
            }
        - lang: Node.js
          source: |-
            const http = require('https');

            const options = {
              method: 'POST',
              hostname: 'app.teable.ai',
              port: null,
              path: '/api/plugin',
              headers: {
                Authorization: 'Bearer REPLACE_BEARER_TOKEN',
                'content-type': 'application/json'
              }
            };

            const req = http.request(options, function (res) {
              const chunks = [];

              res.on('data', function (chunk) {
                chunks.push(chunk);
              });

              res.on('end', function () {
                const body = Buffer.concat(chunks);
                console.log(body.toString());
              });
            });

            req.write(JSON.stringify({
              name: 'string',
              description: 'string',
              detailDesc: 'string',
              logo: 'string',
              url: 'http://example.com',
              config: {
                contextMenu: {width: 0, height: 0, x: 0, y: 0, frozenResize: true, frozenDrag: true},
                view: null,
                dashboard: null,
                panel: null
              },
              helpUrl: 'http://example.com',
              positions: ['dashboard'],
              i18n: {
                en: {title: 'Plugin title', description: 'Plugin description'},
                zh: {title: '插件标题', description: '插件描述'}
              },
              autoCreateMember: true
            }));
            req.end();
        - lang: Python
          source: >-
            import http.client


            conn = http.client.HTTPSConnection("app.teable.ai")


            payload =
            "{\"name\":\"string\",\"description\":\"string\",\"detailDesc\":\"string\",\"logo\":\"string\",\"url\":\"http://example.com\",\"config\":{\"contextMenu\":{\"width\":0,\"height\":0,\"x\":0,\"y\":0,\"frozenResize\":true,\"frozenDrag\":true},\"view\":null,\"dashboard\":null,\"panel\":null},\"helpUrl\":\"http://example.com\",\"positions\":[\"dashboard\"],\"i18n\":{\"en\":{\"title\":\"Plugin
            title\",\"description\":\"Plugin
            description\"},\"zh\":{\"title\":\"插件标题\",\"description\":\"插件描述\"}},\"autoCreateMember\":true}"


            headers = {
                'Authorization': "Bearer REPLACE_BEARER_TOKEN",
                'content-type': "application/json"
            }


            conn.request("POST", "/api/plugin", payload, headers)


            res = conn.getresponse()

            data = res.read()


            print(data.decode("utf-8"))
components:
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer

````